﻿namespace MapTest
{
    using System;
    using System.Windows;
    using System.Windows.Threading;
    using Infragistics.Controls.Maps;

    public partial class MainWindow : Window
    {
        #region Ctor

        public MainWindow()
        {
            InitializeComponent(); 
        }

        #endregion

        #region Event handlers
        int counter = 0;
        void timer_Tick(object sender, EventArgs e)
        {
            try
            {
                // Continuously pan horizontal
                this.map.WindowPositionHorizontal = this.map.WindowRect.X - 0.00001;
                counter++;
                if (counter == 100)
                {
                    (this.map.BackgroundContent as OpenStreetMapImagery).ClearTileCache();
                    GC.Collect();
                    GC.WaitForPendingFinalizers();
                    GC.Collect();
                    counter = 0;
                }
                //this.panTimer.Interval = TimeSpan.FromMilliseconds(500);
            }
            catch (Exception) { }
        }
       
        private void GeoMap_Loaded(object sender, RoutedEventArgs e)
        {
            try
            {
                this.map = sender as Infragistics.Controls.Maps.XamGeographicMap;
                
                // start in D.C.
                Rect washDcRect = new Rect(0.39141999241134462, 0.382525576718907, 0.000099999999999988987, 0.000099999999999988987);
                this.map.WindowRect = washDcRect;

                // pan timer
                this.panTimer = new DispatcherTimer();
                this.panTimer.Tick += timer_Tick;
                this.panTimer.Interval = TimeSpan.FromSeconds(.2);
                this.panTimer.Start();
            }
            catch (Exception) { }
        }

        #endregion

        #region Members

        private DispatcherTimer panTimer = null;
        private Infragistics.Controls.Maps.XamGeographicMap map = null;

        #endregion
    }

    public class Test : OpenStreetMapImagery
    {
        public Test()
        {
            
        }

        public void ClearCache()
        {
            var temp = this.MultiScaleImage.Source;
            this.MultiScaleImage.Source = null;
            this.MultiScaleImage.Source = temp;
        }

    }
}
